// SerialPortDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SerialPort.h"
#include "SerialPortDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSerialPortDlg dialog



CSerialPortDlg::CSerialPortDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSerialPortDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSerialPortDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSerialPortDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
END_MESSAGE_MAP()


// CSerialPortDlg message handlers

BOOL CSerialPortDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSerialPortDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSerialPortDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSerialPortDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CSerialPortDlg::OnBnClickedButton1()
{
	// Sample code to try out the Windows API functions that do I/O on the serial ports
	// by Harr Chen, January 31, 2003

	// This code opens COM1 and COM2, and writes to COM1 at 115200 baud with no parity and 1 stop bit
	// It then tries to read what it wrote on COM2 (to run this code you'll want to use a null modem
	// hookup from COM1 to COM2)

	// Open COM1 and COM2
	HANDLE hCOM1;
	hCOM1 = CreateFile( "COM1",  
		                 GENERIC_READ | GENERIC_WRITE, 
		  	             0, 
				         0, 
					     OPEN_EXISTING,
						 0,
						 0);
	HANDLE hCOM2;
	hCOM2 = CreateFile( "COM2",  
		                 GENERIC_READ | GENERIC_WRITE, 
		  	             0, 
				         0, 
					     OPEN_EXISTING,
						 0,
						 0);
	// Check result of open
	if (hCOM1 == INVALID_HANDLE_VALUE || hCOM2 == INVALID_HANDLE_VALUE) {
		MessageBox("THIS IS THE SUCK - serial port could not be opened");
	}
	else {
		MessageBox("Serial port opened");
	}

	// Set parameters like baud rate, parity and stop bits
	DCB dcb;
	FillMemory(&dcb, sizeof(dcb), 0);
	if (!GetCommState(hCOM1, &dcb)) {
		// Error in GetCommState
		MessageBox("THIS IS THE SUCK - error getting comm state on COM1");
	}

	// Update DCB data
	dcb.BaudRate = CBR_115200;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;

	// Set new state.
	if (!SetCommState(hCOM1, &dcb)) {
		MessageBox("THIS IS THE SUCK - error setting comm state on COM1");
	}

	FillMemory(&dcb, sizeof(dcb), 0);
	if (!GetCommState(hCOM2, &dcb)) {
		// Error in GetCommState
		MessageBox("THIS IS THE SUCK - error getting comm state on COM2");
	}

	// Update DCB data
	dcb.BaudRate = CBR_115200;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;

	// Set new state.
	if (!SetCommState(hCOM2, &dcb)) {
		MessageBox("THIS IS THE SUCK - error setting comm state on COM2");
	}

	char buffer[1];
	buffer[0] = 'A';

	// Write a byte to COM1
	DWORD writtenBytes;

	// Issue write.
	if (WriteFile(hCOM1, buffer, 1, &writtenBytes, NULL) == 0 ||
		writtenBytes != 1 || GetLastError() != 0) {
		MessageBox("THIS IS THE SUCK - error writing to COM1");
	}

	// Read a byte from COM2
	DWORD readBytes;

	// BUG BUG - doesn't work, hangs when I run it (and when I try many other configurations too
	// like overlapping reads and writes)
//	if (ReadFile(hCOM2, buffer, 1, &readBytes, NULL) == 0 ||
//		readBytes != 1 || buffer[0] != 'A' || GetLastError() != 0) {
//		MessageBox("THIS IS THE SUCK - error reading from COM2");
//	}

	// Close the ports
	CloseHandle(hCOM1);
	CloseHandle(hCOM2);

	MessageBox("THE END (if there were no \"THIS IS THE SUCK\" messages we're golden)");
}
